program xqmoon;
 
  {$mode objfpc}{$H+}
    
uses crt,moon,sysutils,dateutils,classes;

const

cl = '|07';
dcl = '|08';
bcl = '|15';

var
y,m,d :word;
mp    : TMoonPhase;
eclipse:TEclipse;
sl : tstringlist;
i:integer;

function getimage(d:tdatetime):string;
  var
    i:integer;
    m:tdatetime;
  begin
    m:=d;
    repeat
    i:=round((age_of_moon(m)*360)/29.55);
    m:=incminute(m,1);
    until fileexists(paramstr(1)+inttostr(i)+'.png.asc')=true;
    result:=paramstr(1)+inttostr(i)+'.png.asc';
  end;

begin
sl:=tstringlist.create;
decodedate(now,y,m,d);
sl.loadfromfile(getimage(now));
for i:=0 to sl.count-1 do sl[i]:=stringofchar(' ',39-length(sl[i]) div 2)+sl[i];
sl.add('');
sl.add(dcl+'_,.-''~''-.,__,.-''~''-.,__,.-''~''-.,_ '+bcl+'Today'+dcl+' _,.-''~''-.,__,.-''~''-.,__,.-''~''-.,__,.-''~');
sl.add('');
if isleapyearcorrect(y) then sl.add(dcl+'Today is : '+dcl+ datetostr(now)+' [ '+cl+'Leap Year'+dcl+' ]') else sl.add(dcl+'Today is : '+bcl+ datetostr(now));
sl.add(dcl+'Its the '+bcl+inttostr(dayofweek(now))+cl+'th day of the week');
sl.add(dcl+'Its the '+bcl+inttostr(dayofthemonth(now))+cl+'th day of the month');
sl.add(dcl+'Its the '+bcl+inttostr(dayoftheyear(now))+cl+'th day of the year');
sl.add(dcl+'Week No : '+bcl+cl+inttostr(WeekNumber(now)));
sl.add('');
sl.add(dcl+'_,.-''~''-.,__,.-''~''-.,__,.-''~''-.,_ '+bcl+'Moon'+dcl+' _,.-''~''-.,__,.-''~''-.,__,.-''~''-.,__,.-''~''');
sl.add('');
sl.add(dcl+'Moon Distance       : '+cl+floattostr(moon_distance(now))+dcl+' Km');
sl.add(dcl+'Age of Moon         : '+cl+floattostr(age_of_moon(now))+dcl+' Days');


mp:=nearest_phase(date);
case mp of
  Newmoon: sl.add(dcl+'Nearest Moon Phase  : '+bcl+'New Moon');
  WaxingCrescrent:sl.add(dcl+'Nearest Moon Phase  : '+cl+'WaxingCresent');
  FirstQuarter:sl.add(dcl+'Nearest Moon Phase  : '+cl+'First Quarter');
  WaxingGibbous:sl.add(dcl+'Nearest Moon Phase  : '+cl+'Waxing Gibbous');
  Fullmoon:sl.add(dcl+'Nearest Moon Phase  : '+cl+'Full Moon');
  WaningGibbous:sl.add(dcl+'Nearest Moon Phase  : '+cl+'Waning Gibbous');
  LastQuarter:sl.add(dcl+'Nearest Moon Phase  : '+cl+'Last Quarter');
  WaningCrescent:sl.add(dcl+'Nearest Moon Phase  : '+cl+'Waning Cresent');
end;

sl.add(dcl+'Next New Moon       : '+cl+datetostr(next_phase(now,Newmoon)));
sl.add(dcl+'Next Full Moon      : '+cl+datetostr(next_phase(now,Fullmoon)));

sl.add(dcl+'Next Blue Moon      : '+ cl+datetostr(next_blue_moon(now)));

sl.add(dcl+'Moon Phase Angle    : '+cl+floattostr(trunc(moon_phase_angle(now))));
sl.add(dcl+'Current Phase       : '+cl+floattostr(current_phase(now)));

sl.add(dcl+'Next Perigee        : '+ cl+datetostr(nextperigee(now)));
sl.add(dcl+'Next Apogee         : '+ cl+datetostr(nextapogee(now)));
sl.add(dcl+'Next Perihel        : '+ cl+datetostr(nextperihel(now)));
sl.add(dcl+'Next Aphel          : '+ cl+datetostr(nextaphel(now)));
sl.add('');
sl.add(dcl+'_,.-''~''-.,__,.-''~''-.,__,.-''~''-.,_ '+bcl+'Other'+dcl+' _,.-''~''-.,__,.-''~''-.,__,.-''~''-.,__,.-''~');
sl.add('');
sl.add(dcl+'Easter              : '+cl+datetostr(EasterDate(y)));
sl.add(dcl+'Chinese New Year    : '+cl+datetostr(ChineseNewYear(y)));
sl.savetofile(paramstr(1)+'xqmoon.ans');

sl.free;
writeln('OK');
end.
